//Turlea Andrei 332CA

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>


void nivele(){
	int i, j, delay = 3000;

	PORTA = 0xFF;
	PORTC = 0xFF;
	PORTD = 0b00011111;
	_delay_ms(delay);
	for (i = 0; i < 4; i++) {
			PORTD = 0b00101111;
			_delay_ms(delay);
			PORTD = 0b00101111;
			_delay_ms(delay);
			PORTD = 0b01001111;
			_delay_ms(delay);
			PORTD = 0b10001111;
			_delay_ms(delay);
			
			PORTD = 0b01001111;
			_delay_ms(delay);
			PORTD = 0b00101111;
			_delay_ms(delay);
			PORTD = 0b0011111;
			_delay_ms(delay);
			
	}
}



void coloane(){
	int i, delay = 1200;
	
	PORTA = 0;
	PORTC = 0;
	PORTD = 0;
	
	for (i = 0; i < 100; i++){
		PORTD = 0b10000000;
		PORTA = 1 << (rand() % 8);
		PORTC = 1 << (rand() % 8);
		PORTD |= 1 << (rand() % 4);
		PORTA |= 1 << (rand() % 8);
		PORTC |= 1 << (rand() % 8);
		PORTD |= 1 << (rand() % 4);
		_delay_ms(delay);
		
		PORTD = 0b01000000;
		_delay_ms(delay/2);
		
		PORTD = 0b00100000;
		_delay_ms(delay/3);
		
		PORTD = 0b00010000;
		_delay_ms(delay/4);
		
		PORTD = 0b00000000;
	}
}

void clipici(){
	int i;

	PORTA = 0xFF;
	PORTC = 0xFF;

	for (i = 4096; i > 0; i/=2){
		PORTD = 0xFF;
		
		_delay_ms(i);

		PORTD = 0x0F;
		
		_delay_ms(i);
	}
}


void rotund(){
	int i, delay = 1000;
	
	for (i = 0; i < 50; i++){
		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b00100011;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b00011100;
		_delay_ms(delay);
		
		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b00010000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b00100000;
		_delay_ms(delay);
		
		PORTA = 0x0F;
		PORTC = 0x00;
		PORTD = 0b01000000;
		_delay_ms(delay);
		
		PORTA = 0xF0;
		PORTC = 0x00;
		PORTD = 0b10000000;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0xF0;
		PORTD = 0b10001100;
		_delay_ms(delay);
		
		PORTA = 0x00;
		PORTC = 0x0F;
		PORTD = 0b01000011;
		_delay_ms(delay);
		
		delay -= 20;
	}
}



int main() {
	DDRA = 0xFF;
    DDRC = 0xFF;
    DDRD = 0xFF;
	
	PORTA = 0xFF;
	PORTC = 0xFF;
	PORTD = 0xFF;
	
	
	
	while (1){
	
		_delay_ms(40000);
		
		
		clipici();
		
		_delay_ms(40000);
		
		
		nivele();
		
		_delay_ms(40000);
		
		
		coloane();
		
		_delay_ms(40000);
		
		
		rotund();
		
		_delay_ms(40000);
		
		
		_delay_ms(40000);
		
		
		coloane();
		
		_delay_ms(20000);
		
		
		rotund();
		
		_delay_ms(20000);
		
		
		nivele();
		
		_delay_ms(20000);
		
		
		clipici();
		
		_delay_ms(20000);
	
	
		
		
	}
	
}